var PORT = 8080;
var gameMode = true;

const mapWidth = 50;
const mapHeight = 50;

var allSockets = {};
var allPlayers = {};
var userCnt = 0;

var express = require('express');
var app = express();
app.use(express.static(__dirname + '/'));
var server = require('http').Server(app);
var io = require('socket.io')(server);
var map = require("./s_map.js");

var maxX = mapWidth * 32;
var maxY = mapHeight * 32;
var newmap = map.generateMap(mapWidth, mapHeight);
var cssMap = newmap["cssMap"];
var map = newmap["map"];
var utilMap = newmap["utilMap"];
var defaultMvnt = 2;

var itemAttrs = {
	"item_boots_boots1": {
		lvl: 1,
		changeMovementLand: 0.1
	},
	"item_boots_boots2": {
		lvl: 2,
		changeMovementLand: 0.15
	},
	"item_boots_boots3": {
		lvl: 3,
		changeMovementLand: 0.2
	},
	"item_boots_boots4": {
		lvl: 4,
		changeMovementLand: 0.25
	},
	"item_boots_boots5": {
		lvl: 5,
		changeMovementLand: 0.3
	},
	"item_tool_axe1": {
		lvl: 1,
		reduceTreeCutSpeed: 300
	},
	"item_tool_axe2": {
		lvl: 2,
		reduceTreeCutSpeed: 550
	},
	"item_tool_axe3": {
		lvl: 3,
		reduceTreeCutSpeed: 700
	},
	"item_tool_axe4": {
		lvl: 4,
		reduceTreeCutSpeed: 900
	},
	"item_tool_axe5": {
		lvl: 5,
		reduceTreeCutSpeed: 1300
	},
	"item_head_head1": {
		lvl: 1,
		armor: 200
	},
	"item_head_head2": {
		lvl: 2,
		armor: 300
	},
	"item_head_head3": {
		lvl: 3,
		armor: 400
	},
	"item_head_head4": {
		lvl: 4,
		armor: 500
	},
	"item_head_head5": {
		lvl: 5,
		armor: 600
	},
	"item_chest_chest1": {
		lvl: 1,
		armor: 200
	},
	"item_chest_chest2": {
		lvl: 2,
		armor: 300
	},
	"item_chest_chest3": {
		lvl: 3,
		armor: 400
	},
	"item_chest_chest4": {
		lvl: 4,
		armor: 500
	},
	"item_chest_chest5": {
		lvl: 5,
		armor: 600
	},
	"item_legs_legs1": {
		lvl: 1,
		armor: 200
	},
	"item_legs_legs2": {
		lvl: 2,
		armor: 300
	},
	"item_legs_legs3": {
		lvl: 3,
		armor: 400
	},
	"item_legs_legs4": {
		lvl: 4,
		armor: 500
	},
	"item_legs_legs5": {
		lvl: 5,
		armor: 600
	},
	"item_legs_legs5": {
		lvl: 5,
		armor: 600
	},
	"item_weapon_sword1": {
		lvl: 1,
		armor: 200
	},
	"item_weapon_sword2": {
		lvl: 2,
		armor: 300
	},
	"item_weapon_sword3": {
		lvl: 3,
		armor: 400
	},
	"item_weapon_sword4": {
		lvl: 4,
		armor: 500
	},
	"item_weapon_sword5": {
		lvl: 5,
		armor: 600
	},
	"item_weapon_stick1": {
		lvl: 1,
		armor: 50
	},
	"item_item_bone1": {
		lvl: 1,
	},
	"item_item_dimond1": {
		lvl: 10,
		changeMovementSpeed : -0.5
	},
}

var items = [];
for (var i in itemAttrs) {
	items.push(i)
}

server.listen(PORT);

console.log("Pirate running on port:" + PORT);
io.on('connection', function (socket) {
	var playerActionTimer = null;
	userCnt++;
	console.log("New user", socket.id);
	allSockets[socket.id] = socket;
	allPlayers[socket.id] = {
		keys: {},
		x: 10,
		y: 10,
		mvnt: defaultMvnt,
		special: {},
		mode: 0, //0 = ship //1 foot
		slots: {
			head: null,
			chest: null,
			legs: null,
			boots: null,
			weapon: null,
			tool: null,
			item: null
		}
	};
	var player = allPlayers[socket.id];
	io.sockets.emit("newPlayer", {
		player: allPlayers[socket.id],
		id: socket.id
	});

	socket.on('disconnect', function () {
		for (var i in player.slots) {
			if (player.slots[i]) {
				let nearFieldCoords = getNearEmptyField(Math.floor(player["x"] / 32), Math.floor(player["y"] / 32));
				let newObj = {
					mapY: nearFieldCoords["y"],
					mapX: nearFieldCoords["x"],
					newName: player.slots[i]
				}
				utilMap[nearFieldCoords["y"]][nearFieldCoords["x"]] = newObj["newName"];
				io.sockets.emit("dropItem", newObj);
			}
		}
		userCnt--;
		delete allSockets[socket.id];
		delete allPlayers[socket.id];
		console.log("User Disconnected:", socket.id);
		io.sockets.emit("playerDisc", socket.id);

	});

	socket.on('getmap', function () {

		newmap["allPlayers"] = allPlayers;
		socket.emit("getmap", newmap);
	});

	socket.on('keyUp', function (key) {
		allPlayers[socket.id]["keys"][key] = false;
		if (key == 32) { //space
			player["action"] = false;
			if (playerActionTimer) {
				clearTimeout(playerActionTimer);
				playerActionTimer = null;
			}
			io.sockets.emit("stopAction", socket.id);
		}
	});

	socket.on('keyDown', function (key) {
		allPlayers[socket.id]["keys"][key] = true;
	});

	socket.on('actionKey', function (key) {
		var groundUnder = getGroundUnderPlayer(player["x"], player["y"]);
		if (player["mode"] == 0) { //ship
			if (groundUnder >= 1) { //its nearly land
				player["mode"] = 1;
				player["special"]["modechange"] = true;
			}
		} else {
			if (groundUnder <= 1) { //its water land
				player["mode"] = 0;
				player["special"]["modechange"] = true;
			}
		};
		//console.log(player["mode"], groundUnder);
		var obj = getNearestObject(player["x"], player["y"]);
		if (obj) {
			obj["socketId"] = socket.id;
			if (playerActionTimer) {
				clearTimeout(playerActionTimer);
				playerActionTimer = null;
			}
			if (obj["name"] == "forest") {
				let cutTime = 2000; //2 Secs

				if (player["slots"]["tool"] && itemAttrs[player["slots"]["tool"]] && itemAttrs[player["slots"]["tool"]]["reduceTreeCutSpeed"] > 0) {
					cutTime -= itemAttrs[player["slots"]["tool"]]["reduceTreeCutSpeed"];
				}

				playerActionTimer = setTimeout(function () {
					utilMap[obj["mapY"]][obj["mapX"]] = "";
					io.sockets.emit("removeUtil", obj);
					socket.emit("stopAnimation", cutTime);
				}, cutTime);
				socket.emit("animation", cutTime);
			} else if (obj["name"] == "treasure-closed") {
				playerActionTimer = setTimeout(function () {
					utilMap[obj["mapY"]][obj["mapX"]] = "treasure-open";
					obj["newName"] = "treasure-open";
					io.sockets.emit("replaceUtil", obj);
					socket.emit("stopAnimation", 2000);

					//Drop a random Item
					let randomItem = getRandomItem(2, 5);
					let nearFieldCoords = getNearEmptyField(obj["mapX"], obj["mapY"]);

					utilMap[nearFieldCoords["y"]][nearFieldCoords["x"]] = randomItem;
					let newObj = {
						mapY: nearFieldCoords["y"],
						mapX: nearFieldCoords["x"],
						newName: randomItem
					}
					io.sockets.emit("dropItem", newObj);
				}, 2000); //2 Secs
				socket.emit("animation", 2000);
			} else if (obj["name"] == "fass") {
				playerActionTimer = setTimeout(function () {
					utilMap[obj["mapY"]][obj["mapX"]] = "";
					io.sockets.emit("removeUtil", obj);
					socket.emit("stopAnimation", 500);

					//Drop a random Item
					let randomItem = getRandomItem(1, 2);
					let nearFieldCoords = getNearEmptyField(obj["mapX"], obj["mapY"]);

					utilMap[nearFieldCoords["y"]][nearFieldCoords["x"]] = randomItem;
					let newObj = {
						mapY: nearFieldCoords["y"],
						mapX: nearFieldCoords["x"],
						newName: randomItem
					}
					io.sockets.emit("dropItem", newObj);
				}, 500); //2 Secs
				socket.emit("animation", 500);
			} else if (obj["name"].split("_")[0] == "item") {
				let itemName = obj["name"];
				utilMap[obj["mapY"]][obj["mapX"]] = "";
				io.sockets.emit("removeUtil", obj);

				let slotArt = obj["name"].split("_")[1];
				if (allPlayers[socket.id]["slots"][slotArt]) { //Slot is not empty so drop it
					let nearFieldCoords = getNearEmptyField(Math.floor(player["x"] / 32), Math.floor(player["y"] / 32));
					let newObj = {
						mapY: nearFieldCoords["y"],
						mapX: nearFieldCoords["x"],
						newName: allPlayers[socket.id]["slots"][slotArt]
					}
					utilMap[nearFieldCoords["y"]][nearFieldCoords["x"]] = newObj["newName"];
					io.sockets.emit("dropItem", newObj);
					//console.log("drop", newObj)
				}

				allPlayers[socket.id]["slots"][slotArt] = itemName;
				socket.emit("addItemToInventar", itemName);


			}

			io.sockets.emit("objAction", obj);
		}
		player["action"] = true;
	});
});

function getNearEmptyField(x, y) {
	x = Math.round(x);
	y = Math.round(y);
	for (var j = 0; j < 10; j++) {
		for (var i = -1 - j; i < 2 + j; i++) {
			for (var k = -1; k < 2; k++) {
				//console.log("check", i, k, y + i, x + k, utilMap[y + i][x + k])
				if (utilMap[y + i][x + k] == "" && cssMap[y + i][x + k] != "water") {
					return {
						y: y + i,
						x: x + k
					}
				}
			}
		}
	}
}

function getRandomItem(minLvl, maxLvl) {
	//console.log("rnd", items.length, getRandomNumber(0, items.length), items)
	while (1) {
		let item = items[getRandomNumber(0, items.length)];
		if (item && (typeof (maxLvl) == "undefined" || typeof (minLvl) == "undefined" || (itemAttrs[item]["lvl"] >= minLvl && itemAttrs[item]["lvl"] <= maxLvl))) {
			return item;
		}
	}
}

function getNearestObject(x, y) {
	var mapX = Math.floor(x / 32);
	var mapY = Math.floor(y / 32);
	var obj = null;
	if (utilMap[mapY][mapX] != "") {
		obj = {
			mapX: mapX,
			mapY: mapY,
			name: utilMap[mapY][mapX]
		}
	} else {
		var rX = x % 32;
		var rY = y % 32;
		var sX = 0;
		var sY = 0;
		if (rX > 6 && rX < 26) { //He stands in the middle of the field (left-><-right)
			if (rY < 16) { //go Up
				sY = -1;
			} else { //go Down
				sY = 1;
			}
		} else if (rY > 6 && rY < 26) { //He stands in the middle of the field (up-><-down)
			if (rX < 16) { //go left
				sX = -1;
			} else { //go right
				sX = 1;
			}
		}

		if (utilMap[mapY + sY][mapX + sX] != "") {
			obj = {
				mapY: mapY + sY,
				mapX: mapX + sX,
				name: utilMap[mapY + sY][mapX + sX]
			}
		}
	}

	return obj;

}

setInterval(function () {
	for (var id in allPlayers) {
		var player = allPlayers[id];
		for (var key in player["keys"]) {
			if (player["keys"][key]) { //if key is pressed
				var tx = 0;
				var ty = 0;

				var mvnt = player["mvnt"];
				if (key == 37) { //left
					tx = -1 * mvnt;
				} else if (key == 38) { //top
					ty = -1 * mvnt;
				} else if (key == 39) { //right
					tx = mvnt;
				} else if (key == 40) { //bottom
					ty = mvnt;
				}

				if (!player["action"]) {
					var newX = player["x"] + tx;
					var newY = player["y"] + ty;

					var groundUnderPlayer = getGroundUnderPlayer(newX, newY);
					if (checkPlayerPosition(newX, newY, groundUnderPlayer, player)) {
						player["x"] = newX;
						player["y"] = newY;
						let mvnt = getPlayerMvnt(player, groundUnderPlayer);
						if (player["slots"]["boots"] && groundUnderPlayer != 0) { //Not water
							player["mvnt"] = mvnt + itemAttrs[player["slots"]["boots"]]["changeMovementLand"];
							//console.log(groundUnderPlayer, player["mvnt"])
						} else {
							player["mvnt"] = mvnt;
						}

						if(player["slots"]["item"] && player["slots"]["item"]["changeMovementSpeed"]) {
							player["mvnt"] = mvnt + itemAttrs[player["slots"]["item"]]["changeMovementSpeed"];
						}

					}

				}
			}
		}
	}
	io.sockets.emit("setpos", allPlayers);
	for (var id in allPlayers) {
		allPlayers[id]["special"] = {};
	}
}, 20);

function checkPlayerPosition(newX, newY, groundUnderPlayer, player) {
	if (newX < 0 || newY < 0 || newX > maxX || newY > maxY) {
		return false;
	}
	if (player["mode"] == 0) { //ship
		if (groundUnderPlayer < 0 || groundUnderPlayer > 2) { //dont move with ship on land
			return false;
		}
	} else {
		if (groundUnderPlayer == 7) { //forrest so dont move
			return false;
		}
	}

	return true;
}

function getGroundUnderPlayer(newX, newY) { //0 = water; 10 = hard ground
	if (newX < 0 || newY < 0 || newX > maxX || newY > maxY) {
		return 0;
	}
	var mapX = Math.floor(newX / 32);
	var mapY = Math.floor(newY / 32);

	if (!cssMap[mapY] || !cssMap[mapY][mapX]) {
		return false;
	}
	var ground = cssMap[mapY][mapX];
	var util = utilMap[mapY][mapX];
	if (util == "forest") {
		return 7;
	}
	var groundSplit = ground.split("_");
	if (groundSplit.length != 2) {
		if (ground == "water") {
			return 0;
		}
		return 10; //Ground
	}
	return parseFloat(groundSplit[1]);
}

function getPlayerMvnt(player, groundUnderPlayer) {
	if (player["mode"] == 0) { //ship
		if (groundUnderPlayer === 1) {
			return 0.5;
		} else if (groundUnderPlayer === 2) {
			return 0.1;
		}
	} else {
		if (groundUnderPlayer === 0) {
			return 0.1;
		} else if (groundUnderPlayer === 1) {
			return 0.5;
		} else if (groundUnderPlayer === 2) {
			return 0.8;
		}
		return 1.5;
	}
	return defaultMvnt;
}

function getRandomNumber(min, max) { //min (inclusive) and max (exclusive)
	return Math.floor(Math.random() * (max - min + 1)) + min;
}